# Class JavaCharStream

java.lang.Object
bsh.JavaCharStream

public class JavaCharStream extends Object
An implementation of interface CharStream, where the stream is assumed to contain only ASCII characters (with java-like unicode escape processing).

## Field Summary

Fields
Modifier and Type
Field
Description
`protected int[]`
`bufcolumn`
`protected char[]`
`buffer`
`protected int[]`
`bufline`
`int`
`bufpos`
`protected int`
`column`
`protected int`
`inBuf`
`protected Reader`
`inputStream`
`protected int`
`line`
`protected int`
`maxNextCharInd`
`protected char[]`
`nextCharBuf`
`protected int`
`nextCharInd`
`protected boolean`
`prevCharIsCR`
`protected boolean`
`prevCharIsLF`
`static final boolean`
`staticFlag`

## Constructor Summary

Constructors
Constructor
Description
`JavaCharStream(InputStream dstream)`
`JavaCharStream(InputStream dstream, int startline, int startcolumn)`
`JavaCharStream(InputStream dstream, int startline, int startcolumn, int buffersize)`
`JavaCharStream(Reader dstream)`
`JavaCharStream(Reader dstream, int startline, int startcolumn)`
`JavaCharStream(Reader dstream, int startline, int startcolumn, int buffersize)`

## Method Summary

Modifier and Type
Method
Description
`void`
`adjustBeginLineColumn(int newLine, int newCol)`
Method to adjust line and column numbers for the start of a token.
`protected void`
`AdjustBuffSize()`
`void`
`backup(int amount)`
`char`
`BeginToken()`
`void`
`Done()`
`protected void`
`ExpandBuff(boolean wrapAround)`
`protected void`
`FillBuff()`
`int`
`getBeginColumn()`
`int`
`getBeginLine()`
`int`
`getColumn()`
Deprecated.
`int`
`getEndColumn()`
`int`
`getEndLine()`
`String`
`GetImage()`
`int`
`getLine()`
Deprecated.
`char[]`
`GetSuffix(int len)`
`protected char`
`ReadByte()`
`char`
`readChar()`
`void`
`ReInit(InputStream dstream)`
`void`
`ReInit(InputStream dstream, int startline, int startcolumn)`
`void`
`ReInit(InputStream dstream, int startline, int startcolumn, int buffersize)`
`void`
`ReInit(Reader dstream)`
`void`
`ReInit(Reader dstream, int startline, int startcolumn)`
`void`
`ReInit(Reader dstream, int startline, int startcolumn, int buffersize)`
`protected void`
`UpdateLineColumn(char c)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### staticFlag

public static final boolean staticFlag

See Also:
  - Constant Field Values

### bufpos

public int bufpos

### bufline

protected int[] bufline

### bufcolumn

protected int[] bufcolumn

### column

protected int column

### line

protected int line

### prevCharIsCR

protected boolean prevCharIsCR

### prevCharIsLF

protected boolean prevCharIsLF

### inputStream

protected Reader inputStream

### nextCharBuf

protected char[] nextCharBuf

### buffer

protected char[] buffer

### maxNextCharInd

protected int maxNextCharInd

### nextCharInd

protected int nextCharInd

### inBuf

protected int inBuf

## Constructor Details

### JavaCharStream

public JavaCharStream(Reader dstream, int startline, int startcolumn, int buffersize)

### JavaCharStream

public JavaCharStream(Reader dstream, int startline, int startcolumn)

### JavaCharStream

public JavaCharStream(Reader dstream)

### JavaCharStream

public JavaCharStream(InputStream dstream, int startline, int startcolumn, int buffersize)

### JavaCharStream

public JavaCharStream(InputStream dstream, int startline, int startcolumn)

### JavaCharStream

public JavaCharStream(InputStream dstream)

## Method Details

### ExpandBuff

protected void ExpandBuff(boolean wrapAround)

### FillBuff

protected void FillBuff() throws IOException

Throws:
  `IOException`

### ReadByte

protected char ReadByte() throws IOException

Throws:
  `IOException`

### BeginToken

public char BeginToken() throws IOException

Throws:
  `IOException`

### AdjustBuffSize

protected void AdjustBuffSize()

### UpdateLineColumn

protected void UpdateLineColumn(char c)

### readChar

public char readChar() throws IOException

Throws:
  `IOException`

### getColumn

public int getColumn()
Deprecated.

See Also:
  - `getEndColumn()`

### getLine

public int getLine()
Deprecated.

See Also:
  - `getEndLine()`

### getEndColumn

public int getEndColumn()

### getEndLine

public int getEndLine()

### getBeginColumn

public int getBeginColumn()

### getBeginLine

public int getBeginLine()

### backup

public void backup(int amount)

### ReInit

public void ReInit(Reader dstream, int startline, int startcolumn, int buffersize)

### ReInit

public void ReInit(Reader dstream, int startline, int startcolumn)

### ReInit

public void ReInit(Reader dstream)

### ReInit

public void ReInit(InputStream dstream, int startline, int startcolumn, int buffersize)

### ReInit

public void ReInit(InputStream dstream, int startline, int startcolumn)

### ReInit

public void ReInit(InputStream dstream)

### GetImage

public String GetImage()

### GetSuffix

public char[] GetSuffix(int len)

### Done

public void Done()

### adjustBeginLineColumn

public void adjustBeginLineColumn(int newLine, int newCol)
Method to adjust line and column numbers for the start of a token.